/*
   This file is part of MD5, a graphical MD5 Checksum generator/checker.

   Copyright (C) 2002 Jason Kingan
      jasonk@toast442.org

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.

   The GNU General Public License is contained in the file COPYING.
*/
#include "stdafx.h"
#include "md5.h"
#include "md5Dlg.h"
#include <direct.h>
#include "md5core.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

char * progname = "md5sum";

#define	FOPRTXT	"r"
#define	FOPRBIN	"rb"

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMd5Dlg dialog

CMd5Dlg::CMd5Dlg(CWnd* pParent /*=NULL*/)
	: CDialogMgr(CMd5Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMd5Dlg)
	m_nMode = -1;
	m_strDirectory = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMd5Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogMgr::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMd5Dlg)
	DDX_Control(pDX, IDC_DIRSEL, m_Dirsel);
	DDX_Control(pDX, IDC_FILELIST, m_List);
	DDX_Radio(pDX, IDC_RADIO1, m_nMode);
	DDX_Text(pDX, IDC_DIRECTORY, m_strDirectory);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMd5Dlg, CDialogMgr)
	//{{AFX_MSG_MAP(CMd5Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CLIPBOARD, OnClipboard)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_DIRSEL, OnDirsel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMd5Dlg message handlers

BOOL CMd5Dlg::OnInitDialog()
{
	CDialogMgr::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_DropTarget.Register(this);
	bin_mode = 1;
	verbose = 0;

	m_List.InsertColumn(1,"Filename",LVCFMT_LEFT,200,1);
	m_List.InsertColumn(1,"File Checksum",LVCFMT_LEFT,225,2);
	m_List.InsertColumn(1,"Actual Checksum",LVCFMT_LEFT,225,2);

	m_ImageList.Create(IDB_BITMAP1,16,4,RGB(255,0,255));

	m_List.SetImageList(&m_ImageList,LVSIL_SMALL);

	CPane * top =new CPane ( this, HORIZONTAL );
	CPane * mid =new CPane ( this, HORIZONTAL );

	top->addItem ( IDOK, NORESIZE);
	top->addItem ( IDC_CLEAR, NORESIZE);
	top->addItem ( IDC_RADIO1, NORESIZE);
	top->addItem ( IDC_RADIO2, NORESIZE);
	mid->addItem( IDC_CLIPBOARD, NORESIZE);
	mid->addItem( IDC_SAVE, NORESIZE);
	mid->addItem ( IDC_DIRECTORY, GREEDY);
	mid->addItem ( IDC_DIRSEL, NORESIZE);

	m_pRootPane=new CPane ( this, VERTICAL );
	m_pRootPane->addPane ( top, ABSOLUTE_VERT );
	m_pRootPane->addPane ( mid, ABSOLUTE_VERT );
	m_pRootPane->addItem ( IDC_FILELIST, GREEDY);

	
	m_Dirsel.SetIcon(AfxGetApp()->LoadIcon((const char*)IDI_DIRICON));

	m_nMode = 0;
	m_strDirectory="<From Check File>";
	UpdateData(FALSE);

	UpdateLayout();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMd5Dlg::AddItem(char * pszFilename, unsigned char * checksum_1,
					  unsigned char * checksum_2,int nIcon)
{
	m_strItems += print_digest(checksum_1);
	m_strItems += " *";
	m_strItems += pszFilename;
	m_strItems += "\n";

	m_List.InsertItem(0,pszFilename,nIcon);
	m_List.SetItem(0,1,LVIF_TEXT,print_digest(checksum_1),0,0,0,0);
	m_List.SetItem(0,2,LVIF_TEXT,print_digest(checksum_2),0,0,0,0);
}

void CMd5Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogMgr::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMd5Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogMgr::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMd5Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMd5Dlg::Go()
{
	char buf[4096];
	char * pTemp;
	char * pOrig;

	UpdateData();

	if(m_nMode == 0) {
	
		m_List.DeleteAllItems();
		m_strItems.Empty();
		strcpy(buf,m_strFile);
		pOrig = buf;

		pTemp = buf+strlen(buf);
		
		while(*pTemp--!='\\' && pTemp>pOrig);

		if(pTemp>pOrig)
			*(pTemp+1) = 0;
		
		if(m_strDirectory[0] == '<')
			_chdir(buf);
		else		
			_chdir(m_strDirectory);
		md5main(m_strFile.GetBuffer(m_strFile.GetLength()),1);
		m_strFile.ReleaseBuffer();
	} else {

		strcpy(buf,m_strFile);
		pOrig = buf;

		pTemp = buf+strlen(buf);
		
		while(*pTemp--!='\\' && pTemp>pOrig);

		if(pTemp>pOrig)
			*(pTemp+1) = 0;

		m_strFile = pTemp+2;
		*(pTemp+1)='\\';
		*(pTemp+2)=0;

		_chdir(buf);

		md5main(m_strFile.GetBuffer(m_strFile.GetLength()),0);
		m_strFile.ReleaseBuffer();
	}
}


BOOL CMd5Dlg::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CDialogMgr::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

DROPEFFECT CDrop::OnDragEnter( CWnd* pWnd, COleDataObject* pDataObject, DWORD dwKeyState, CPoint point )
{
	return DROPEFFECT_COPY;

}

DROPEFFECT CDrop::OnDragOver( CWnd* pWnd, COleDataObject* pDataObject, DWORD dwKeyState, CPoint point )
{
	return DROPEFFECT_COPY;

}


BOOL CDrop::OnDrop( CWnd* pWnd, COleDataObject* pDataObject, DROPEFFECT dropEffect, CPoint point )
{
	
    HGLOBAL  hGlobal;
    LPCSTR   pData;
	
    FORMATETC fmtetc =
	{ CF_HDROP, NULL, DVASPECT_CONTENT, -1, TYMED_HGLOBAL };
    STGMEDIUM stgmed;

    TCHAR szFileName[_MAX_PATH + 1];

    if(pDataObject->GetData(CF_HDROP, &stgmed, &fmtetc))
    {
        HDROP hdrop = (HDROP)GlobalLock(stgmed.hGlobal);
		
        if (NULL != hdrop)
        {
            UINT nFiles = DragQueryFile(hdrop, (UINT)-1, NULL, 0);
			
            for(UINT nNames = 0; nNames < nFiles; nNames++)
            {
                ZeroMemory(szFileName, _MAX_PATH + 1);
                DragQueryFile
                    (hdrop, nNames, (LPTSTR)szFileName, _MAX_PATH + 1);

				((CMd5Dlg*)pWnd)->m_strFile = szFileName;
				((CMd5Dlg*)pWnd)->Go();

			}
            GlobalUnlock(hdrop);
			
        }
        ReleaseStgMedium(&stgmed);
		
    } else {
		
		// Get text data from ColeDataObject.
		hGlobal=pDataObject->GetGlobalData(CF_TEXT);
		
		// Get a pointer to data.
		pData=(LPCSTR)GlobalLock(hGlobal);
		ASSERT(pData!=NULL);
		
		// Set text in the dropped window.
		((CEdit*)pWnd)->SetWindowText(pData);
		
		// Unlock memory.
		GlobalUnlock(hGlobal);
	}

	return TRUE;
}


CString CMd5Dlg::print_digest(unsigned char *p)
{
	int i;
	char buf[10];
	CString strRet;

	for (i = 0; i < 16; ++i) {
		sprintf(buf,"%02x", *p++);
		strRet += buf;
	}

	return strRet;

}


int CMd5Dlg::md5main(char * szFile, BOOL bCheck)
{
	int check = 1;
	unsigned char digest[16];

	if(bCheck) {

		FILE * fp = fopen(szFile, "r");
		do_check(fp);
		fclose(fp);
	} else {
		FILE * fp = fopen(szFile, "rb");
		if(!fp || mdfile(fp, digest)) {
			AddItem(szFile,digest,digest,0);
		} else {
			AddItem(szFile,digest,digest,1);
		}
		if(fp)
			fclose(fp);
	}
		
	return 0;
}

/*
int
__main(int argc, char **argv)
{
	int opt, rc = 0;
	int check = 0;
	FILE *fp;
	unsigned char digest[16];

	progname = *argv;
	while ((opt = pgp_getopt(argc, argv, "cbvp:h")) != EOF) {
		switch (opt) {
			case 'c': check = 1; break;
			case 'v': verbose = 1; break;
			case 'b': bin_mode = 1; break;
			default: usage();
		}
	}
	argc -= optind;
	argv += optind;
	if (check) {
		switch (argc) {
			case 0: fp = stdin; break;
			case 1: if ((fp = fopen(*argv, FOPRTXT)) == NULL) {
					perror(*argv);
					exit(2);
				}
				break;
			default: usage();
		}
		exit(do_check(fp));
	}
	if (argc == 0) {
		if (mdfile(stdin, digest)) {
			fprintf(stderr, "%s: read error on stdin\n", progname);
			exit(2);
		}
		print_digest(digest);
		printf("\n");
		exit(0);
	}
	for ( ; argc > 0; --argc, ++argv) {
		if (bin_mode)
			fp = fopen(*argv, FOPRBIN);
		else
			fp = fopen(*argv, FOPRTXT);
		if (fp == NULL) {
			perror(*argv);
			rc = 2;
			continue;
		}
		if (mdfile(fp, digest)) {
			fprintf(stderr, "%s: error reading %s\n", progname, *argv);
			rc = 2;
		} else {
			print_digest(digest);
			printf(" %c%s\n", bin_mode ? '*' : ' ', *argv);
		}
		fclose(fp);
	}
	exit(rc);
    return 0;
}
*/
int CMd5Dlg::mdfile(FILE *fp, unsigned char *digest)
{
	unsigned char buf[1024];
	MD5_CTX ctx;
	int n;

	MD5Init(&ctx);
	while ((n = fread(buf, 1, sizeof(buf), fp)) > 0)
		MD5Update(&ctx, buf, n);
	MD5Final(digest, &ctx);
	if (ferror(fp))
		return -1;
	return 0;
}

int CMd5Dlg::hex_digit(int c)
{
	if (c >= '0' && c <= '9')
		return c - '0';
	if (c >= 'a' && c <= 'f')
		return c - 'a' + 10;
	return -1;
}

int CMd5Dlg::get_md5_line(FILE *fp, unsigned char *digest, char *file)
{
	char buf[1024];
	int i, d1, d2, rc;
	char *p = buf;

	if (fgets(buf, sizeof(buf), fp) == NULL)
		return -1;

	for (i = 0; i < 16; ++i) {
		if ((d1 = hex_digit(*p++)) == -1)
			return 0;
		if ((d2 = hex_digit(*p++)) == -1)
			return 0;
		*digest++ = d1*16 + d2;
	}
	if (*p++ != ' ')
		return 0;
	/*
	 * next char is an attribute char, space means text file
	 * if it's a '*' the file should be checked in binary mode.
	 */
	if (*p == ' ')
		rc = 1;
	else if (*p == '*')
		rc = 2;
	else {
		fprintf(stderr, "%s: unrecognized line: %s", "md5sum", buf);
		return 0;
	}
	++p;
	i = strlen(p);
	if (i < 2 || i > 255)
		return 0;
	p[i-1] = '\0';
	strcpy(file, p);
	return rc;
}

int CMd5Dlg::do_check(FILE *chkf)
{
	int rc, ex = 0, failed = 0, checked = 0;
	unsigned char chk_digest[16], file_digest[16];
	char filename[256];
	FILE *fp;
	unsigned int flen = 14;

	while ((rc = get_md5_line(chkf, chk_digest, filename)) >= 0) {
		if (rc == 0)	/* not an md5 line */
			continue;
		if(filename[strlen(filename)-1] == '\r' ||
			filename[strlen(filename)-1] == '\n')
			filename[strlen(filename)-1] = 0;
		
		if (verbose) {
			if (strlen(filename) > flen)
				flen = strlen(filename);
			fprintf(stderr, "%-*s ", flen, filename);
		}
		if (bin_mode || rc == 2)
			fp = fopen(filename, FOPRBIN);
		else
			fp = fopen(filename, FOPRTXT);
		if (fp == NULL) {
			AddItem(filename,chk_digest,file_digest,2);
			fprintf(stderr, "%s: can't open %s\n", progname, filename);
			ex = 2;
			continue;
		}
		if (mdfile(fp, file_digest)) {
			AddItem(filename,chk_digest,file_digest,2);
			fprintf(stderr, "%s: error reading %s\n", progname, filename);
			ex = 2;
			fclose(fp);
			continue;
		}
		fclose(fp);
		if (memcmp(chk_digest, file_digest, 16) != 0) {
			AddItem(filename,chk_digest,file_digest, 0);
			if (verbose)
				fprintf(stderr, "FAILED\n");
			else
				fprintf(stderr, "%s: MD5 check failed for '%s'\n", progname, filename);
			++failed;
		} else {
			if (verbose)
				fprintf(stderr, "OK\n");
			AddItem(filename,chk_digest,file_digest,1);
		}

		++checked;
	}
	if (verbose && failed)
		fprintf(stderr, "%s: %d of %d file(s) failed MD5 check\n", progname, failed, checked);
	if (!checked) {
		fprintf(stderr, "%s: no files checked\n", progname);
		return 3;
	}
	if (!ex && failed)
		ex = 1;
	return ex;
}

/*
void CMd5Dlg::OnSize(UINT nType, int cx, int cy) 
{
	static bFirst;
	static offset_left;
	static offset_right;
	static offset_bottom;
	static offset_top;

	CDialog::OnSize(nType, cx, cy);
	
	if(m_List.GetSafeHwnd()) {
		
		if(!bFirst) {
			CRect parent;
			GetWindowRect(parent);
			CRect cr;
			m_List.GetWindowRect(cr);

			offset_left = cr.left - parent.left-4;
			offset_right = parent.right - cr.right-4;
			offset_top = cr.top - parent.top-22;
			offset_bottom = parent.bottom - cr.bottom;
			bFirst = TRUE;
		}
		m_List.MoveWindow(offset_left,offset_top,cx-offset_left - offset_right,
			offset_bottom - offset_top + cy - offset_bottom-12,TRUE);
	}
	
}
*/

void CMd5Dlg::OnClipboard() 
{
	char * lp;
	HANDLE hText;

	if (( hText = GlobalAlloc( GHND, (DWORD)m_strItems.GetLength())) == NULL)
		return;

	/* get TEXT format data*/
	lp = (LPSTR)GlobalLock( hText);
	memcpy(lp,(const char*)m_strItems,m_strItems.GetLength());
	GlobalUnlock( hText);

	if(::OpenClipboard( GetSafeHwnd())) {
		::EmptyClipboard();
		::SetClipboardData( CF_OEMTEXT, hText);
		::CloseClipboard();
	}

}

void CMd5Dlg::OnSave() 
{
	CFileDialog dlg(FALSE);

	if(dlg.DoModal() == IDOK) {
		CString str = dlg.GetPathName();

		FILE * fp = fopen(str,"w");
		fwrite(m_strItems,m_strItems.GetLength(),1,fp);
		fclose(fp);
	}

	
}

void CMd5Dlg::OnClear() 
{
	m_List.DeleteAllItems();	
	m_strDirectory="<From Check File>";
	UpdateData(FALSE);
}

void CMd5Dlg::OnDirsel() 
{
	char path[MAX_PATH];
	LPITEMIDLIST pi;
	LPMALLOC pm;
	BROWSEINFO bi;
	bi.hwndOwner = this->GetSafeHwnd();
	bi.pidlRoot = NULL;
	bi.pszDisplayName = path;
	bi.lpszTitle="Select Source Folder";
	bi.ulFlags = BIF_VALIDATE;
	bi.lpfn = NULL;
	bi.lParam = 0;
	bi.iImage = 0;
	SHGetMalloc(&pm);
	pi = SHBrowseForFolder(&bi);	
	SHGetPathFromIDList(pi,path);

	pm->Free(pi);

	if(path[0])
		m_strDirectory = path;
	else
	m_strDirectory="<From Check File>";
	UpdateData(FALSE);

}
