// md5Dlg.h : header file
//

#if !defined(AFX_MD5DLG_H__9E499FE4_3998_11D3_9BC3_0050049EC14F__INCLUDED_)
#define AFX_MD5DLG_H__9E499FE4_3998_11D3_9BC3_0050049EC14F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CMd5Dlg dialog

/*
   This file is part of MD5, a graphical MD5 Checksum generator/checker.

   Copyright (C) 2002 Jason Kingan
      jasonk@toast442.org

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.

   The GNU General Public License is contained in the file COPYING.
*/

#include "DialogMgr.h"

class CDrop : public COleDropTarget
{
public:
	virtual DROPEFFECT OnDragEnter( CWnd* pWnd, COleDataObject* pDataObject, DWORD dwKeyState, CPoint point );
	virtual DROPEFFECT OnDragOver( CWnd* pWnd, COleDataObject* pDataObject, DWORD dwKeyState, CPoint point );
	virtual BOOL OnDrop( CWnd* pWnd, COleDataObject* pDataObject, DROPEFFECT dropEffect, CPoint point );
};


class CMd5Dlg : public CDialogMgr
{
// Construction
public:
	CMd5Dlg(CWnd* pParent = NULL);	// standard constructor
	DECLARE_LAYOUT();
	CDrop m_DropTarget;
	CString m_strFile;
	void Go();

	int do_check(FILE *chkf);
	int mdfile(FILE *fp, unsigned char *digest);
	int get_md5_line(FILE *fp, unsigned char *digest, char *file);
	int hex_digit(int c);
	CString print_digest(unsigned char *p);
	int md5main(char * szFile, BOOL bCheck);
	int verbose;
	int bin_mode;

	CString m_strItems;

	CImageList m_ImageList;

	void AddItem(char * pszFilename, unsigned char * checksum_1, 
		unsigned char * checksum_2,int nIcon);

// Dialog Data
	//{{AFX_DATA(CMd5Dlg)
	enum { IDD = IDD_MD5_DIALOG };
	CButton	m_Dirsel;
	CListCtrl	m_List;
	int		m_nMode;
	CString	m_strDirectory;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMd5Dlg)
	public:
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CMd5Dlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnClipboard();
	afx_msg void OnSave();
	afx_msg void OnClear();
	afx_msg void OnDirsel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MD5DLG_H__9E499FE4_3998_11D3_9BC3_0050049EC14F__INCLUDED_)
